<template>
    <div id="app">
        <loading :status="isLoading" />
        <vHeader />
        <main id="scroller">
            <router-view />
            <vFooter />
        </main>
    </div>
</template>
<script>
import gsap from 'gsap/dist/gsap.min'
import ScrollTrigger from 'gsap/dist/ScrollTrigger.min'
import vHeader from './layout/header'
import vFooter from './layout/footer'


gsap.registerPlugin(ScrollTrigger)

export default {
    components: {
        vHeader,
        vFooter,
        loading,
    },
    mixins: [scroller],
    data() {
        return {
            isLoading: true,
        }
    },
    mounted() {
        this.isLoading = false
    },
    methods: {
    },
    watch: {
        $route() {
            this.$nextTick(() => {
                this.seizeAppHeight()
                ScrollTrigger.refresh()
            })
        },
    },
    mounted() {
        this.initWrapperScroll()
    },
    methods: {
        seizeAppHeight() {
            const scroller = this.$el.querySelector('#scroller')
            this.$el.style.height = `${scroller.offsetHeight}px`
        },
        initWrapperScroll() {
            this.seizeAppHeight()
            gsap.to(this.$el.querySelector('#scroller'), {
                scrollTrigger: {
                    trigger: this.$el,
                    start: 'top top',
                    end: 'bottom bottom',
                    scrub: 1,
                    // onToggle: (self) => console.log('toggled, isActive:', self.isActive),
                    // onUpdate: (self) => {
                    //     console.log('progress:', self.progress.toFixed(3), 'direction:', self.direction, 'velocity', self.getVelocity())
                    // },
                },
                ease: 'none',
                y: '-100%',
                marginTop: '100vh',
            })
        },
    },
}
</script>
<style lang="scss">
@import './styles/reset.scss';
#app {
    font-family: Avenir, Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    width: 100%;
    position: relative;
    #scroller {
        position: fixed;
        width: 100%;
        top: 0;
        left: 0;
        padding-top: map-get($header-height, desktop);
        @include rwd('desktop', 'below') {
            padding-top: map-get($header-height, mobile);
        }
    }
}
</style>
